// m: 
//  3  23.04.2014

function MainChain(canvas, vCanvas) {
    //  

    var context = canvas.getContext("2d");  //  context  
    var vContext = vCanvas.getContext("2d");//  context  

    const Pi = 3.1415926;                   //  ""

    const m0 = 1;                           //  
    const T0 = 1;                           //   (   )
    const a0 = 1;                           //   ( )

    const k0 = 2 * Pi / T0;                 //  
    const C0 = m0 * k0 * k0;                //  

    // ***    ***

    const m = 1 * m0;                 	    // 
    const C = 1 * C0;                 	    // 
    const numStart = 24;                    //   

    // ***    ***

    const fps = 50;             	        // frames per second -     ( )
    const spf = 10;              		    // steps per frame -      ( )
    const dt  = 0.4 * T0 / fps;      	    //   ( )

    //  

    const scale = canvas.height / a0;       //         
    const wScale = canvas.width;		    //     
    const hScale = canvas.height;		    //     
    const w = wScale / scale;		        //     
    const h = hScale / scale;		        //     
    const chainHeightScale = hScale/2;      //      

    //    
    const vWScale = vCanvas.width;          //     
    const vHScale = vCanvas.height;         //     
    const vHeightScale = vHScale/2;         //      
    const vAxisScale = vHScale * 0.4;       //   "y"  
    const uvWResize = vWScale/wScale;       //     

    //   

    var particles;                          //  
    var num, pDist;                         //       (  )
    MainChain.prototype.setNum = function(n){num = n; pDist = w/(num-1);};       //    
    MainChain.prototype.setNum(numStart);
    var uAxisScale;                         //   "y" 
    MainChain.prototype.newSystem = function(conf){
        MainChain.prototype.actualConf = conf;
        particles = [];
        for (var i = 1; i < num + 1; i++) {
            var b = [];

            b.x0 = pDist*(i-1);             //     
            b.x0Scale = b.x0*scale;         //     
            b.fu = 0;   b.vu = 0;   b.uu = 0;   //  ; ;  . . 

            conf(b, i);                     //     
            particles[i] = b;               //    
        }

        //    
        particles[0] = particles[num];
        particles[num+1] = particles[1];

        //       (     )
        var sumvu = 0;
        for (var i0 = 1; i0 < num+1; i0++) sumvu += particles[i0].vu;
        var vuAverage = sumvu/num;
        for (var i1 = 1; i1 < num+1; i1++) particles[i1].vu -= vuAverage;

        //   "y"
        var confCoeff = 1;
        if (conf == MainChain.prototype.conf_random) confCoeff = Math.sqrt(num)/6;
        if (conf == MainChain.prototype.conf_one || conf == MainChain.prototype.conf_stair2) confCoeff = num/5;
        if (conf == MainChain.prototype.conf_stair3) confCoeff = num/10;
        uAxisScale = hScale/(num/35) * confCoeff;
    };

    //   
    var v0 = 1*a0/T0;                       // conf_random -   
    var sinNum = 2;                         // conf_sin -     
    var hillDiv = 1/4;                      // conf_hill -  () ,   ""

    // 
    MainChain.prototype.conf_random = function(b){b.vu = v0*(2*Math.random()-1);};
    MainChain.prototype.conf_sin = function(b, i){b.vu = Math.sin(2*Pi * i/num*sinNum);};
    MainChain.prototype.conf_one = function(b, i){if (i == Math.ceil(num/2)) b.vu = 0.5; else b.vu = 0;};
    MainChain.prototype.conf_stair2 = function(b, i){if (i%4 == 0 || (i-1)%4 == 0) b.vu = 1; else b.vu = 0;};
    MainChain.prototype.conf_stair3 = function(b, i){if (i%6 == 0 || (i-1)%6 == 0 || (i-2)%6 == 0) b.vu = 1; else b.vu = 0;};
    MainChain.prototype.conf_hill = function(b, i){
        var nd2 = hillDiv *num/2;            //  ,      / 2 ( )
        if (i > num/2-nd2 && i < num/2+nd2) b.vu = (1 - (i-num/2)*(i-num/2)/(nd2*nd2));    // 
        else b.vu = 0;
    };

    //   

    function control() {
        physics();
        draw();
    }

    //   

    function physics(){
        for (var s=1; s<=spf; s++) {// ,     
            for (var i=1; i<particles.length-1; i++){
                particles[i].fu = C*(particles[i+1].uu - 2*particles[i].uu + particles[i-1].uu);
                particles[i].vu += particles[i].fu / m * dt;
            }
            //   
            for (var i2=1; i2 < particles.length-1; i2++ ) particles[i2].uu += particles[i2].vu * dt;
        }
    }

    // 

    function draw(){
        function clearAndPrepairCtx(ctx, wS, hS, lineHeight){       //      
            ctx.clearRect(0, 0, wS, hS);                            //  
            ctx.strokeStyle = 'gray';
            ctx.beginPath();
            ctx.moveTo(0, lineHeight);
            ctx.lineTo(wS, lineHeight);
            ctx.stroke();
            ctx.strokeStyle = 'black';
        }

        // 
        clearAndPrepairCtx(context, wScale, hScale, chainHeightScale);
        context.beginPath();
        context.moveTo(particles[1].x0Scale, chainHeightScale + particles[1].uu*uAxisScale);
        for (var i = 2; i < particles.length-1; i++)
            context.lineTo(particles[i].x0Scale, chainHeightScale + particles[i].uu*uAxisScale);
        context.stroke();

        //  
        clearAndPrepairCtx(vContext, vWScale, vHScale, vHeightScale);
        vContext.beginPath();
        vContext.moveTo(particles[1].x0Scale * uvWResize, vHeightScale + particles[1].vu*vAxisScale);
        for (var i0 = 2; i0 < particles.length-1; i0++)
            vContext.lineTo(particles[i0].x0Scale * uvWResize, vHeightScale + particles[i0].vu*vAxisScale);
        vContext.stroke();
    }

    //  

    MainChain.prototype.newSystem(MainChain.prototype.conf_hill);
    setInterval(control, 1000/fps);
}